﻿<template>
        <Card>
            <MemberForm :member="member" @formSubmit="handleSubmit" />
        </Card>
</template>

<script lang="ts" setup>
import MemberForm from "@/components/members/MemberForm.vue"
import Card from "@/components/layout/Card.vue";
import {useI18n} from "vue3-i18n";
import {IAuthenticatedMember, Member} from "@/types/entities";
import {notifyError, notifySuccess} from "@/notify";
import {useMemberService} from "@/inversify.config";
import {useRouter} from "vue-router";
import { ref } from "vue";
import { IUpdateMemberRequest } from "@/types/requests/updateMemberRequest";

    // eslint-disable-next-line no-undef
 

    const { t } = useI18n()
    const router = useRouter();
    const memberService = useMemberService();

    const member = ref<IAuthenticatedMember|undefined>(await memberService.getCurrentMember());

    async function handleSubmit(member: Member) {
        let succeededOrNotResponse = await memberService.updateMember(member as IUpdateMemberRequest)
        if (succeededOrNotResponse && succeededOrNotResponse.succeeded) {
            notifySuccess(t('validation.member.edit.success'))
            setTimeout(() => {
                router.back();
            }, 1500);
        } else {
            let errorMessages = succeededOrNotResponse.getErrorMessages('validation.member.edit');
            if (errorMessages.length == 0)
                notifyError(t('validation.member.edit.errorOccured'))
            else
                notifyError(errorMessages[0])
        }
    }
</script>